SSLKEYLOGFILE Extension for Encrypted Client Hello (ECH)
Internet-Draft draft-ietf-tls-ech-keylogfile-01
Yaroslav Rosomakho
Zscaler
yrosomakho@zscaler.com
Hannes Tschofenig
University of Applied Sciences Bonn-Rhein-Sieg
Hannes.Tschofenig@gmx.net
21 October 2024
Security
Transport Layer Security
encrypted client hello
sslkeylog
This document specifies an extension to the SSLKEYLOGFILE format to support the logging of information about Encrypted Client Hello (ECH) related secrets. Two new labels are introduced, namely ECH_SECRET and ECH_CONFIG, which log the Hybrid Public Key Encryption (HPKE)-derived shared secret and the ECHConfig used for the ECH, respectively.
This extension aims to facilitate debugging of TLS connections employing ECH.
About This Document
The latest revision of this draft can be found at https://tlswg.github.io/draft-ietf-tls-ech-keylogfile/draft-ietf-tls-ech-keylogfile.html. Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-tls-ech-keylogfile/.
Discussion of this document takes place on the Transport Layer Security Working Group mailing list (mailto:tls@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/tls/. Subscribe at https://www.ietf.org/mailman/listinfo/tls/.
Source for this draft and an issue tracker can be found at https://github.com/tlswg/draft-ietf-tls-ech-keylogfile.
Introduction
Debugging protocols with TLS can be difficult due to encrypted communications. Analyzing these messages in diagnostic and debug tools requires inspecting the encrypted content. Various TLS implementations have informally adopted a file format to log the secret values generated by the TLS key schedule, aiding in this analysis.
In many implementations, the file that the secrets are logged to is specified in an environment variable named "SSLKEYLOGFILE". [I-D.ietf-tls-keylogfile] standardizes this format. With the introduction of [I-D.ietf-tls-esni] additional secrets are derived during the handshake to encrypt the ClientHello message using Hybrid Public Key Encryption (HPKE) [RFC9180]. This document extends the SSLKEYLOGFILE format to also offer support for the ECH extension to enable debugging of ECH-enabled connections. The proposed extension can also be used with all protocols that support ECH, including TLS 1.3 [RFC8446], DTLS 1.3 [RFC9147] and QUIC [RFC9000][RFC9001].
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
SSLKEYLOGFILE Labels for ECH
This document defines two new labels for SSLKEYLOGFILE format: ECH_SECRET and ECH_CONFIG. The client SHOULD log the labels if it offered ECH regardless of server acceptance. The server MAY log the labels only if it successfully decrypted and accepted ECH offered by the client. The 32-byte random value from the Outer ClientHello message is used as the client_random value for these log records. The client MUST NOT log the labels for connections that use the GREASE ECH extension (see Section 6.2 of [I-D.ietf-tls-esni]).
ECH_SECRET
This label corresponds to the KEM shared secret derived during the HPKE key schedule process. Length of the secret is defined by the KEM negotiated for use with ECH.
ECH_CONFIG
This label is used to log the ECHConfig used for construction of the ECH extension. Note that the value is logged in hexadecimal representation, similarly to other entries in the SSLKEYLOGFILE.
Client_random for other TLS 1.3 SSLKEYLOGFILE Entries
The SSLKEYLOGFILE uses the random value from the ClientHello message as a "connection identifier". This creates ambiguity since the TLS handshake with ECH contains two different random values, one in the Outer ClientHello structure and the second one in the Inner ClientHello.
The SSLKEYLOGFILE entries corresponding to TLS 1.3 secrets for connections that successfully negotiated ECH MUST use the random from the Inner ClientHello structure. In all other cases the random value from the Outer ClientHello structure MUST be used.
Security Considerations
The applicability statement of [I-D.ietf-tls-keylogfile] also applies to this document: if unauthorized entities gain access to the logged secrets then the core guarantees that TLS provides are completely undermined.
This specification extends the SSLKEYLOGFILE specification [I-D.ietf-tls-keylogfile] and therefore introduces the following threats:
- Access to the ECH_SECRET record in the SSLKEYLOGFILE allows the attacker to decrypt the ECH extension and thereby reveal the content of the ClientHello message, including the payload of the Server Name Indication (SNI) extension.
- Access to the HPKE-established shared secret introduces a potential attack surface against the HPKE library since access to this keying material is normally not available otherwise.
Implementers MUST take measures to prevent unauthorized access to the SSLKEYLOGFILE text file.
As per the SSLKEYLOGFILE specification [I-D.ietf-tls-keylogfile], this extension is intended for use in environments where TLS protects only test data. While the access it provides to TLS connections can be valuable for debugging during development, this mechanism MUST NOT be used in production environments. To minimize the risk of accidental activation in production, implementers SHOULD incorporate appropriate compile-time controls.
IANA Considerations
IANA is requested to create a new registry "SSLKEYLOGFILE Labels", within the existing "Transport Layer Security (TLS) Parameters" registry page. This new registry reserves labels used for SSLKEYLOGFILE entries. The initial contents of this registry are as follows.
Value | Description | Reference
CLIENT_RANDOM | Master secret in TLS 1.2 and earlier | [I-D.ietf-tls-keylogfile]
CLIENT_EARLY_TRAFFIC_SECRET | Secret for client early data records | [I-D.ietf-tls-keylogfile]
EARLY_EXPORTER_MASTER_SECRET | Early exporters secret | [I-D.ietf-tls-keylogfile]
CLIENT_HANDSHAKE_TRAFFIC_SECRET | Secret protecting client handshake | [I-D.ietf-tls-keylogfile]
SERVER_HANDSHAKE_TRAFFIC_SECRET | Secret protecting server handshake | [I-D.ietf-tls-keylogfile]
CLIENT_TRAFFIC_SECRET_0 | Secret protecting client records post handshake | [I-D.ietf-tls-keylogfile]
SERVER_TRAFFIC_SECRET_0 | Secret protecting server records post handshake | [I-D.ietf-tls-keylogfile]
EXPORTER_SECRET | Exporter secret after handshake | [I-D.ietf-tls-keylogfile]
This documents defines two additional labels in Section 3:
- ECH_SECRET, which contains KEM shared secret for the ECH
- ECH_CONFIG, which contains ECHConfig used for construction of the ECH
New assignments in the "SSLKEYLOGFILE Labels" registry will be administered by IANA through Expert Review [RFC8126]. Designated Experts are requested to ensure that defined labels do not overlap in names or semantics, and have clear definitions.
Registration requests must be sent to the tls@ietf.org mailing list for review and comment, with an appropriate subject (e.g., "Request for SSLKEYLOGFILE Label: example").
Within the review period of two weeks, the Designated Experts will either approve or deny the registration request, communicating this decision to the review list and IANA. Denials should include an explanation and, if applicable, suggestions as to how to make the request successful.
IANA must only accept registry updates from the Designated Experts and should direct all requests for registration to the TLS mailing list.
References
Normative References
[I-D.ietf-tls-keylogfile]

The SSLKEYLOGFILE Format for TLS
Martin Thomson
Mozilla
29 April 2024
Internet-Draft draft-ietf-tls-keylogfile-02
[I-D.ietf-tls-esni]

TLS Encrypted Client Hello
Eric Rescorla
Independent
Kazuho Oku
Fastly
Nick Sullivan
Cryptography Consulting LLC
Christopher A. Wood
Cloudflare
15 September 2024
Internet-Draft draft-ietf-tls-esni-22
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8126]

Guidelines for Writing an IANA Considerations Section in RFCs
M. Cotton
B. Leiba
T. Narten
June 2017
BCP 26
RFC 8126
DOI 10.17487/RFC8126
Informative References
[RFC9180]

Hybrid Public Key Encryption
R. Barnes
K. Bhargavan
B. Lipp
C. Wood
February 2022
RFC 9180
DOI 10.17487/RFC9180
[RFC8446]

The Transport Layer Security (TLS) Protocol Version 1.3
E. Rescorla
August 2018
RFC 8446
DOI 10.17487/RFC8446
[RFC9147]

The Datagram Transport Layer Security (DTLS) Protocol Version 1.3
E. Rescorla
H. Tschofenig
N. Modadugu
April 2022
RFC 9147
DOI 10.17487/RFC9147
[RFC9000]

QUIC: A UDP-Based Multiplexed and Secure Transport
J. Iyengar, Ed.
M. Thomson, Ed.
May 2021
RFC 9000
DOI 10.17487/RFC9000
[RFC9001]

Using TLS to Secure QUIC
M. Thomson, Ed.
S. Turner, Ed.
May 2021
RFC 9001
DOI 10.17487/RFC9001
Acknowledgments
We would like to thank Stephen Farrell, Rich Salz, Martin Thomson and Peter Wu for their review comments.